// a little bit HTMLテキスト編集ツール リトルビット / by オレンジ工房
// alb.js 2015-07-28版
// ※最新版、サポート：http://alb.orange-factory.com
// ※このコメントは削除しないでください。
// ※改変は自己責任でお願いします。
// -------------------------------------
/* 初期設定 */
var edit_on = 0;
$(function(){

	// アイキャッチ処理
	$("#eyecatch")
		.css("height", window.innerHeight)
		.css("padding-top", Math.floor(window.innerHeight/2)-75)
		.delay(800)
		.slideUp();

	// ボタンを変数に投入
	$btnStart  = $('#btnStart');
	$btnSave   = $('#btnSave');
	$btnCancel = $('#btnCancel');
	$btnSend   = $('#btnSend');
	// それぞれの処理
	$btnStart .click(btnStart);
	$btnSave  .click(btnSave).hide();
	$btnCancel.click(btnCancel).hide();
	$btnSend  .click(btnSend);
	$("#loginform").submit(function(){btnSend();return false;});

	// ヒント表示エリア
	$hint = $("#hint");

	// フレームのjQueryオブジェクト
	$editarea = $('#editarea');
	// フレーム内コンテンツのwindowオブジェクト
	editWindow = document.getElementById("editarea").contentWindow;


	// 内容物を一旦非表示に
	$("#toolbar").hide();
	$("#formbar").hide();

	// フレームのサイズ調整
	setFrameSize();					// まず1回実行
	window.onresize = setFrameSize;	// 今後はウィンドウリサイズ時に実行

	// ログイン状態チェックのため、サーバに空の問合せ
	send();

	// ロゴクリックで終了
	$("#logo")
		.css("cursor", "pointer")
		.click(function(){
			$("#eyecatch img").attr("src", 'img/logo_byebye.png');
			$("#eyecatch")
				.css("height", window.innerHeight)
				.css("padding-top", Math.floor(window.innerHeight/2)-75)
				.slideDown()
				.delay(500)
				.fadeOut()
				.promise().done(function(){window.location.href=editWindow.location.href});
		});

});
// -----------------------------------------------------------------------------
/* ----- 受信 */
// -------------------------------------
/* JSON受信 */
function dispSuccess(data) {

	// 受け取ったデータをゴッソリ保存
	json = data;

	switch(data.mode) {

		// 編集したい！の返答。
		case 'edit':
			// 許可
			if (data.result) {
				json.message = data.message || '編集モードです。';
				styleEditable();	// 編集画面スタイル
			}
			// ダメ
			else {
				message = data.message || '編集できません。';
				if (data.file) message += '(ファイル名: ' + data.file + ')';
				json.message = message;
			}
			dispBase();	// 表示
			break;

		// 保存したい！の返答。
		case 'save':
			// できた
			if (data.result) {
				edit_on = 0;
				json.message = '保存しました。';
				styleDefault();
			}
			// ダメ
			else {
				message = "保存できませんでした。";
				if (data.message) message += data.message;
				if (data.file)    message += '(ファイル名: ' + data.file + ')';
				json.message = message;
			}
			dispBase();	// 表示
			break;

		// 初期設定へ(親ウィンドウ)
		case 'init':
			window.location.href = 'init.php';
			break;

		// ログイン要求
		case 'login':
			$("#toolbar").hide();
			$("#formbar").show();
			$hint.html(data.message || 'ログインしてください。');
			break;

		// それ以外のとき
		default:
			styleDefault();
			dispBase();	// 表示
	}
}
// -------------------------------------
/* 通常表示 */
function dispBase() {

	// サーバから指示されたURLを表示してるか確認
	if (json.url && editWindow.location.href != json.url) {
		editWindow.location.href = json.url;
	}

	// ツールバーの表示切替
	if (json.error) {
		$("#toolbar").hide();
	}
	else {
		$("#toolbar").show();
	}

	// フォームはいらない
	$("#formbar").hide();

	// メッセージはjsonに入ってるやつ（またはデフォルトメッセージ）
	var message = json.message || '編集するページに移動してから、編集ボタンをクリック。';
	$hint.html(message);
}
// -------------------------------------
/* エラー */
function dispError(e) {
	// 基本メッセージ
	var message = 'データを受け取れませんでした。';
	// 特定のステータスの時
	switch (e.status) {
		case 500:
			message += '<a href="init.php">初期設定</a>は終了していますか？';
			break;
		case 404:
			message += "サーバ側システムが見つかりませんでした。";
			break;
	}
	// 表示
	$hint.html(message);
	// 編集モードだったとしても終了させる
	edit_on = 0;
	$("#toolbar").hide();
	$("#formbar").hide();
}
// -----------------------------------------------------------------------------
/* ----- 送信 */
// -------------------------------------
/* 編集開始 */
function btnStart() {
	send('mode=edit');
	return false;
}
// -------------------------------------
/* 保存 */
function btnSave() {
	if (! edit_on) {
		$hint.html("編集した後に保存してください。");
		return false;
	}
	var post_data = 'mode=save';
	$("." + json.cname, editWindow.document)
		.each(function(i){
			post_data += "&edit=" + encodeURIComponent($(this).html());
		});
	send(post_data);
	return false;
}
// -------------------------------------
/* キャンセル */
function btnCancel() {
	// 確認
	if (edit_on
	&& confirm("編集中の内容は失われます。\nよろしいですか？") == false){
		// 何もしない
	}
	else {
		json.message = "";
		edit_on = 0;
		dispBase();
		styleDefault();
	}
	return false;
}
// -------------------------------------
/* ログイン */
function btnSend () {
	send('mode=login&pwd=' + $("#pwd").val());
	return false;
}
// -------------------------------------
/* 送信処理 */
function send(data) {
	// 表示中URLは必ず追加
	if (editWindow.location.href) {
		if (data) data += '&';
		data += 'url=' + encodeURIComponent(editWindow.location.href);
	}
	// 送る
	$.ajax({
		url:      'alb.cgi',
		type:     'POST',
		data:     data,
		dataType: 'json',
		success:  dispSuccess,
		error:    dispError,
	});
}

// -----------------------------------------------------------------------------
/* ----- 表示 */
// -------------------------------------
/* 編集モード */
function styleEditable() {

	/* ツールバーに表示するボタンの切り替え */
	$btnStart.hide();
	$btnSave.show();
	$btnCancel.show();

	/* editable設定 */
	$("."+json.cname, editWindow.document)
		.attr("contenteditable", "true")
		.on('focus', function(){
			if (!edit_on) {
				edit_check = $(this).html();
			}
		})
		.on('blur keyup input', function(){
			if (!edit_on) {
				if ($(this).html() !== edit_check) {
					edit_on = 1;
				}
			}
		})
		.on('paste', onPaste )
		.each(function(){
			$this = $(this);
			if ($this.css("position") == 'static'
			|| $this.css("position") == '') {
				$this.css("position", "relative");
			}

		});

	/* 背景ツブし */
	$("body", editWindow.document)
		.append('<div id="albGrayout"></div>');

	/* 編集用スタイル読み込み */
	$("head", editWindow.document)
		.append('<link rel="stylesheet" href="' + json.csspath + '">');
}
// -------------------------------------
/* ペースト時処理 */
function onPaste(e) {
	if (!edit_on && $(this).html() !== edit_check) edit_on = 1;
	// クリップボードの中身をテキストで取得
	var pastecontent;
	if (e.originalEvent.clipboardData) {
		pastecontent = e.originalEvent.clipboardData.getData('text/plain') || "";
	}
	else if (clipboardData) {
		pastecontent = window.clipboardData.getData('Text') || "";
	}
	if (!pastecontent) return false;

	// カーソルのNODEと位置
	var mynode = editWindow.getSelection().anchorNode;
	var offset = editWindow.getSelection().anchorOffset;

	// NODEの内容編集。ペーストの代替。
	var origintext;
	if (mynode.textContent !== undefined) {
		origintext = mynode.textContent || "";
		mynode.textContent = origintext.substr(0,offset)
		                   + pastecontent
						 + origintext.substr(offset);
	}
	else if (mynode.innerText !== undefined) {
		origintext = mynode.innerText || "";
		mynode.innerText = origintext.substr(0,offset)
		                 + pastecontent
						 + origintext.substr(offset);
	}
	// ペーストイベント自体はキャンセルする。
	return false;
}
// -------------------------------------
/* 通常モード */
function styleDefault() {

	/* ツールバーに表示するボタンの切り替え */
	$btnStart.show();
	$btnSave.hide();
	$btnCancel.hide();

	// 単純にページを再読み込み
	editWindow.location.reload();
}
// -------------------------------------
/* フレームサイズ調整 */
function setFrameSize () {
	// ヘッダの高さ80px + ボーダー1px
	var h = window.innerHeight - 81;
	$editarea.css('height', h);
	$("#frame").css('height', h);
}

